<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" indent="yes" omit-xml-declaration = "yes"
  encoding="utf-8"/>

<xsl:template match="textarea[@id = 'forum_desc']">
  <desc>
    <xsl:value-of select="text()"/>
  </desc>
</xsl:template>

<xsl:template match="input[@id = 'forum_name']">
  <name>
    <xsl:value-of select="@value"/>
  </name>
</xsl:template>

<xsl:template match="select[@id = 'forum_type']/option[@selected = 'selected']">
  <type>
    <xsl:value-of select="@value"/>
  </type>
</xsl:template>

<xsl:template match="input[@name = 'desc_parse_bbcode']">
  <desc_parse_bbcode>
  <xsl:if test="@checked = 'checked'">1</xsl:if>
  <xsl:if test="not(@checked = 'checked')">0</xsl:if>
  </desc_parse_bbcode>
</xsl:template>

<xsl:template match="input[@name = 'desc_parse_smilies']">
  <desc_parse_smilies>
  <xsl:if test="@checked = 'checked'">1</xsl:if>
  <xsl:if test="not(@checked = 'checked')">0</xsl:if>
  </desc_parse_smilies>
</xsl:template>

<xsl:template match="input[@name = 'desc_parse_urls']">
  <desc_parse_urls>
  <xsl:if test="@checked = 'checked'">1</xsl:if>
  <xsl:if test="not(@checked = 'checked')">0</xsl:if>
  </desc_parse_urls>
</xsl:template>

<xsl:template match="select[@name = 'forum_status']/option[@selected = 'selected']">
  <status>
    <xsl:value-of select="@value"/>
  </status>
</xsl:template>

<xsl:template match="input[@name = 'display_subforum_list' and @checked = 'checked']">
  <display_subforum_list>
    <xsl:value-of select="@value"/>
  </display_subforum_list>
</xsl:template>

<xsl:template match="input[@name = 'display_on_index' and @checked = 'checked']">
  <display_on_index>
    <xsl:value-of select="@value"/>
  </display_on_index>
</xsl:template>

<xsl:template match="input[@name = 'enable_post_review' and @checked = 'checked']">
  <enable_post_review>
    <xsl:value-of select="@value"/>
  </enable_post_review>
</xsl:template>

<xsl:template match="input[@name = 'enable_indexing' and @checked = 'checked']">
  <enable_indexing>
    <xsl:value-of select="@value"/>
  </enable_indexing>
</xsl:template>

<xsl:template match="input[@name = 'display_recent' and @checked = 'checked']">
  <display_recent>
    <xsl:value-of select="@value"/>
  </display_recent>
</xsl:template>

<xsl:template match="input[@name = 'topics_per_page']">
  <topics_per_page>
    <xsl:value-of select="@value"/>
  </topics_per_page>
</xsl:template>

<xsl:template match="input[@name = 'link_display_on_index' and @checked = 'checked']">
  <link_display_on_index>
    <xsl:value-of select="@value"/>
  </link_display_on_index>
</xsl:template>

<xsl:template match="input[@name = 'forum_link']">
  <forum_link>
    <xsl:value-of select="@value"/>
  </forum_link>
</xsl:template>

<xsl:template match="input[@name = 'forum_link_track' and @checked = 'checked']">
  <forum_link_track>
    <xsl:value-of select="@value"/>
  </forum_link_track>
</xsl:template>

<xsl:template match="input[@name = 'forum_rules_link']">
  <forum_rules_link>
    <xsl:value-of select="@value"/>
  </forum_rules_link>
</xsl:template>

<xsl:template match="textarea[@name = 'forum_rules']">
  <forum_rules>
    <xsl:value-of select="text()"/>
  </forum_rules>
</xsl:template>

<xsl:template match="input[@name = 'rules_parse_bbcode']">
  <rules_parse_bbcode>
  <xsl:if test="@checked = 'checked'">1</xsl:if>
  <xsl:if test="not(@checked = 'checked')">0</xsl:if>
  </rules_parse_bbcode>
</xsl:template>

<xsl:template match="input[@name = 'rules_parse_smilies']">
  <rules_parse_smilies>
  <xsl:if test="@checked = 'checked'">1</xsl:if>
  <xsl:if test="not(@checked = 'checked')">0</xsl:if>
  </rules_parse_smilies>
</xsl:template>

<xsl:template match="input[@name = 'rules_parse_urls']">
  <rules_parse_urls>
  <xsl:if test="@checked = 'checked'">1</xsl:if>
  <xsl:if test="not(@checked = 'checked')">0</xsl:if>
  </rules_parse_urls>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="/">
  <forum>
    <xsl:apply-templates/>
  </forum>
</xsl:template>

</xsl:stylesheet>
