<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" indent="yes" omit-xml-declaration = "yes"
  encoding="utf-8"/>

<xsl:template match="div[starts-with(@class,'post')]">
  <post>
    <post-id>
      <xsl:value-of select="substring-after(@id, 'p')"/>
    </post-id>
    <user>
      <xsl:value-of select=".//a[contains(@href,'viewprofile')]"/>
    </user>
    <date>
      <day>
      <xsl:value-of select="substring-before(substring-after(normalize-space(.//p[@class='author']/text()[position()=2]),' '), ' ')"/>
      </day>
      <month>
      <xsl:value-of select="substring-before(substring-after(substring-after(normalize-space(.//p[@class='author']/text()[position()=2]),' '), ' '), ' ')"/>
      </month>
      <year>
      <xsl:value-of select="substring-before(substring-after(substring-after(substring-after(normalize-space(.//p[@class='author']/text()[position()=2]),' '), ' '), ' '), ',')"/>
      </year>
      <hour>
      <xsl:value-of select="substring-before(substring-after(substring-after(normalize-space(.//p[@class='author']/text()[position()=2]),' '), ', '), ':')"/>
      </hour>
      <minute>
      <xsl:value-of select="substring-after(substring-after(normalize-space(.//p[@class='author']/text()[position()=2]),' '), ':')"/>
      </minute>
      <raw>
      <xsl:value-of select="substring-after(normalize-space(.//p[@class='author']/text()[position()=2]),' ')"/>
      </raw>
    </date>
    <user-color>
      <xsl:value-of select="substring(substring-after(.//a[contains(@href,'viewprofile')]/@style,'#'),1,6)"/>
    </user-color>
  </post>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="/">
  <posts>
    <xsl:apply-templates/>
  </posts>
</xsl:template>

</xsl:stylesheet>
