<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" indent="yes" omit-xml-declaration = "yes"
  encoding="utf-8"/>

<xsl:template match="li[starts-with(@class,'row bg1') or starts-with(@class,'row bg2')]">
  <topic>
    <topic-id>
      <xsl:value-of select="substring-after(dl[1]/dt[1]/a[1]/@href,'t=')"/>
    </topic-id>
    <forum-id>
      <xsl:value-of select="substring-after(dl[1]/dt[1]/a[1]/@href,'f=')"/>
    </forum-id>
    <user>
      <xsl:value-of select="dl[1]/dt[1]/a[contains(@href,'viewprofile')]"/>
    </user>
    <date>
      <day>
      <xsl:value-of select="substring-before(substring-after(normalize-space(dl[1]/dt[1]/a[contains(@href,'memberlist')]/following-sibling::text()), ' '), ' ')"/>
      </day>
      <month>
      <xsl:value-of select="substring-before(substring-after(substring-after(normalize-space(dl[1]/dt[1]/a[contains(@href,'memberlist')]/following-sibling::text()), ' '), ' '), ' ')"/>
      </month>
      <year>
      <xsl:value-of select="substring-before(substring-after(substring-after(substring-after(normalize-space(dl[1]/dt[1]/a[contains(@href,'memberlist')]/following-sibling::text()), ' '), ' '), ' '), ',')"/>
      </year>
      <hour>
      <xsl:value-of select="substring-before(substring-after(substring-after(normalize-space(dl[1]/dt[1]/a[contains(@href,'memberlist')]/following-sibling::text()), ' '), ', '), ':')"/>
      </hour>
      <minute>
      <xsl:value-of select="substring-after(substring-after(normalize-space(dl[1]/dt[1]/a[contains(@href,'memberlist')]/following-sibling::text()), ' '), ':')"/>
      </minute>
      <raw>
      <xsl:value-of select="substring-after(normalize-space(dl[1]/dt[1]/a[contains(@href,'memberlist')]/following-sibling::text()), ' ')"/>
      </raw>
    </date>
    <user-color>
      <xsl:value-of select="substring(substring-after(dl[1]/dt[1]/a[contains(@href,'viewprofile')]/@style,'#'),1,6)"/>
    </user-color>
  </topic>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="/">
  <topics>
    <xsl:apply-templates/>
  </topics>
</xsl:template>

</xsl:stylesheet>
