<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" indent="yes" omit-xml-declaration = "yes"
  encoding="utf-8"/>

<xsl:template match="input[@id='subject']">
  <subject>
    <xsl:value-of select="@value"/>
  </subject>
</xsl:template>

<xsl:template match="textarea[@id='message']">
  <content>
    <xsl:value-of select="text()"/>
  </content>
</xsl:template>

<xsl:template match="input[@name='icon' and @checked='checked']">
  <icon>
    <xsl:value-of select="@value"/>
  </icon>
</xsl:template>

<xsl:template match="input[@id='disable_bbcode']">
  <do_bbcode>
    <xsl:if test="@checked='checked'">0</xsl:if>
    <xsl:if test="not(@checked='checked')">1</xsl:if>
  </do_bbcode>
</xsl:template>

<xsl:template match="input[@id='disable_smilies']">
  <do_smilies>
    <xsl:if test="@checked='checked'">0</xsl:if>
    <xsl:if test="not(@checked='checked')">1</xsl:if>
  </do_smilies>
</xsl:template>

<xsl:template match="input[@id='disable_magic_url']">
  <do_magic_url>
    <xsl:if test="@checked='checked'">0</xsl:if>
    <xsl:if test="not(@checked='checked')">1</xsl:if>
  </do_magic_url>
</xsl:template>

<xsl:template match="input[@id='attach_sig']">
  <do_attach_sig>
    <xsl:if test="@checked='checked'">1</xsl:if>
    <xsl:if test="not(@checked='checked')">0</xsl:if>
  </do_attach_sig>
</xsl:template>

<xsl:template match="input[@id='lock_topic']">
  <do_lock_topic>
    <xsl:if test="@checked='checked'">1</xsl:if>
    <xsl:if test="not(@checked='checked')">0</xsl:if>
  </do_lock_topic>
</xsl:template>

<xsl:template match="input[@id='lock_post']">
  <do_lock_post>
    <xsl:if test="@checked='checked'">1</xsl:if>
    <xsl:if test="not(@checked='checked')">0</xsl:if>
  </do_lock_post>
</xsl:template>

<xsl:template match="input[@name='topic_type' and @checked='checked']">
  <type>
    <xsl:value-of select="@value"/>
  </type>
</xsl:template>

<xsl:template match="input[@name='topic_time_limit']">
  <stick_topic_time_limit>
    <xsl:value-of select="@value"/>
  </stick_topic_time_limit>
</xsl:template>

<xsl:template match="div[@id='poll-panel']">
  <poll>
    <question>
      <xsl:value-of select=".//input[@name='poll_title']/@value"/>
    </question>
    <options>
      <xsl:value-of select=".//textarea[@name='poll_option_text']"/>
    </options>
    <options_per_user>
      <xsl:value-of select=".//input[@name='poll_max_options']/@value"/>
    </options_per_user>
    <poll_length>
      <xsl:value-of select=".//input[@name='poll_length']/@value"/>
    </poll_length>
    <poll_vote_change>
      <xsl:if test=".//input[@name='poll_vote_change']/@checked='checked'">1</xsl:if>
      <xsl:if test="not(.//input[@name='poll_vote_change']/@checked='checked')">0</xsl:if>
    </poll_vote_change>
  </poll>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="/">
  <post>
    <xsl:apply-templates/>
  </post>
</xsl:template>

</xsl:stylesheet>
