#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

char *months[] = {
#include "months.h"
};

int get_month(char *m)
{
  int i;
  for (i=0; months[i]; i+=2) {
    if (!strcmp(months[i], m)) {
      i /= 2;
      i %= 12;
      return i;
    }
  }
  printf("WARNING: unknown month '%s', pretend it's january\n", m);
  return 0;
}

long make_date(char *day, char *month, char *year, char *hour, char *minute)
{
  time_t r;
  struct tm t;
  t.tm_sec = 0;
  sscanf(minute, "%d", &t.tm_min);
  sscanf(hour, "%d", &t.tm_hour);
  sscanf(day, "%d", &t.tm_mday);
  t.tm_mon = get_month(month);
  sscanf(year, "%d", &t.tm_year);
  t.tm_year -= 1900;
  t.tm_isdst = 0;
  r = mktime(&t);
  if (r == -1) r = 0;
  return r;
}

void usage(void)
{
  printf("usage: testtime.exe <day> <month> <year> <hour> <minute>\n");
  printf("  month is 'Jan' 'Feb' and so on\n");
  exit(1);
}

int main(int n, char **v)
{
  if (n != 6) usage();
  printf("your time is: %ld\n", make_date(v[1], v[2], v[3], v[4], v[5]));
  printf("  (it should not be 0...)\n");
  return 0;
}
