#include "common.h"

#include <stdlib.h>
#include <libxml/tree.h>
#include <string.h>
#include <time.h>

#include "xml.h"
#include "buffer.h"

char randchar(void)
{
  char *t = "abcdefghijklmnopqrstuvwxyz0123456789_";

  return t[(int)(37.*rand()/(RAND_MAX+1.))];
}

void make_pass(char *p)
{
  int i;
  for (i=0; i<8; i++) p[i] = randchar();
}

char *get_email(char *user_id)
{
  xmlDocPtr doc;
  xmlNodePtr root;
  char url[512];
  char *page;
  printf("Get email of user number %s...\n", user_id);
  if (strlen(user_id) > 256) { printf("PANIC: %s\n", __FUNCTION__); exit(1); }
  sprintf(url, /* CHECKED */
          "/adm/index.php?i=users&mode=overview&u=%s&sid=%s",
          user_id, get_sid());
again:
  page = get(url);
  if (!page) { printf("PANIC:%s:%d\n", __FUNCTION__, __LINE__); exit(1); }
  if (strstr(page, "<body id=\"errorpage\">")) {
    printf("WARNING: the server returned an error page, let's try again.\n");
    goto again;
  }
  doc = transform(page, "get_user_email.xslt");
  if (!doc) {
    printf("PANIC: %s:%d error with transform?\n", __FILE__, __LINE__);
    exit(1);
  }
  root = xmlDocGetRootElement(doc);
  if (!root) {
    printf("PANIC: %s:%d\n", __FILE__, __LINE__);
    exit(1);
  }
  NP(root->children);
  printf("  mail: %s\n", xmlNodeListGetRawString(doc, root->children, 0));
  printf("...done\n");
  return xmlNodeListGetRawString(doc, root->children, 0);
}

#define Ss do { fprintf(sqlfile, "fwrite($f, \""); } while (0) /**/
#define Se do { fprintf(sqlfile, "\");\n"); } while (0) /**/
#define Sfs do { fprintf(sqlfile, "fwrite($f, "); } while (0) /**/
#define Sfe do { fprintf(sqlfile, ");\n"); } while (0) /**/
#define S(x) do { fprintf(sqlfile, "%s", x); } while (0) /**/
#define I(x) do { fprintf(sqlfile, "%d", x); } while (0) /**/
#define LI(x) do { fprintf(sqlfile, "%ld", x); } while (0) /**/
void get_users(void)
{
  xmlDocPtr doc;
  xmlNodePtr root;
  xmlNodePtr cur;
  int start = 0;
  int nstart;
  char *page;
  char *page2 = 0;
  char *next;
  char uu[64];
  FILE *sqlfile;
  FILE *textfile;
  char *user_email = "no@no.com";
#if 0
  /* hash is crc32("no@no.com") . strlen("no@no.com") */
  int user_email_hash1 = -83999;
  int user_email_hash2 = 11119;
#endif
  char password[9];
  password[8] = 0;

  sqlfile = fopen("users.php", "wb");
  textfile = fopen("users.txt", "wb");
  if (!sqlfile) {
    printf("PANIC: error opening users.php\n");
    exit(1);
  }
  if (!textfile) {
    printf("PANIC: error opening users.txt\n");
    exit(1);
  }
  fprintf(textfile, "#format: <username> <user id> <user password>");
  fprintf(textfile, " <user date of join>\n");
  fprintf(sqlfile, "<?php\n");
  Ss;
  S("INSERT INTO phpbb_users (user_id, user_regdate,");
  S("username, username_clean, user_password, user_email,");
  S(" user_email_hash, user_permissions, user_sig, user_occ, user_interests) VALUES ");
  Se;

  printf("Getting users\n");
more:
  sprintf(uu, "/memberlist.php?start=%d", start); /* CHECKED */
again:
  page = get(uu);
  if (!page) exit(1);
  if (strstr(page, "<body id=\"errorpage\">")) {
    printf("WARNING: the server returned an error page, let's try again.\n");
    goto again;
  }
  /* barbarian copy because we call get() in get_mail (yeah, dirty hack) */
  if (page2) { free(page2); page2= 0; }
  page2 = strdup(page); if (!page2) { printf("PANIC:out of mem\n");exit(1); }
  next = page2;

  /* extract users */
  doc = transform(page2, "get_users.xslt");
  if (!doc) {
    printf("PANIC: %s:%d error with transform?\n", __FILE__, __LINE__);
    exit(1);
  }

  /* no user? hum, maybe start again? */
  root = xmlDocGetRootElement(doc);
  if (!root) {
warn:
    printf("WARNING: no user found, SQL error? Let's try again...\n");
    goto again;
  }
  cur = root->children;
  if (!cur) goto warn;
  while (cur) {
    NP(cur->children);
    NP(cur->children->next);
    NP(cur->children->next->children);
    NP(cur->children->next->children->content);
    if (!strcmp(cur->children->next->children->content, "2")) {
      cur = cur->next;
      continue;
    }

    /* make a password */
    make_pass(password);

    /* user id */
    Ss;
    S("(");
    S(cur->children->next->children->content); S(", ");
    /* user regdata */
    NP(cur->children->next->next);
    NP(cur->children->next->next->children);
    NP(cur->children->next->next->children->children);
    NP(cur->children->next->next->children->children->content);
    NP(cur->children->next->next->children->next);
    NP(cur->children->next->next->children->next->children);
    NP(cur->children->next->next->children->next->children->content);
    NP(cur->children->next->next->children->next);
    NP(cur->children->next->next->children->next->next);
    NP(cur->children->next->next->children->next->next->children);
    NP(cur->children->next->next->children->next->next->children->content);
    NP(cur->children->next->next->children->next->next->next);
    NP(cur->children->next->next->children->next->next->next->children);
    NP(cur->children->next->next->children->next->next->next->children->content);
    NP(cur->children->next->next->children->next->next->next->next);
    NP(cur->children->next->next->children->next->next->next->next->children);
    NP(cur->children->next->next->children->next->next->next->next->children->content);
    LI(make_date(cur->children->next->next->children->
                             children->content,
                      translate_month(cur->children->next->next->
                             children->next->
                             children->content),
                      cur->children->next->next->children->next->next->
                             children->content,
                      cur->children->next->next->children->next->next->next->
                             children->content,
                      cur->children->next->next->children->next->
                             next->next->next->
                             children->content)); S(", '");
    /* user name */
    NP(cur->children->children);
    NP(cur->children->children->content);
    Se; Sfs; S("mysql_real_escape_string(\"");
    S(sql_escape(cur->children->children->content)); S("\")"); Sfe; Ss;
    S("', '");
    /* user clean name */
    Se; Sfs; S("mysql_real_escape_string(utf8_clean_string(\"");
    S(sql_escape(cur->children->children->content)); S("\"))"); Sfe; Ss;
    S("', '");
    Se; Sfs; S("md5(\"");
    S(password); S("\")"); Sfe; Ss; S("', '");
    user_email = get_email(cur->children->next->children->content);
    Se; Sfs; S("mysql_real_escape_string(\"");
    S(user_email); S("\")"); Sfe; Ss; S("', ");

    Se; Sfs; S("crc32(\"");
    S(user_email); S("\") . strlen(\"");
    S(user_email); S("\")");
    Sfe; Ss; S(", ");

    S("'','','','')");
    Se;

    /* users.txt: <username> <user id> <user password> <user date of join> */
    fprintf(textfile, "%s", cur->children->children->content);
    fprintf(textfile, " %s", cur->children->next->children->content);
    fprintf(textfile, " %s", password);
    fprintf(textfile, " %s %s %s, %s:%s\n",
            cur->children->next->next->children->
                             children->content,
                      translate_month(cur->children->next->next->
                             children->next->
                             children->content),
                      cur->children->next->next->children->next->next->
                             children->content,
                      cur->children->next->next->children->next->next->next->
                             children->content,
                      cur->children->next->next->children->next->
                             next->next->next->
                             children->content);

    cur = cur->next;
    if (cur) { Ss; S(", "); Se; }
  }

  xmlFreeDoc(doc);

  /* go next page (if any) */
  /* we need to catch the min of values > current */
  nstart = start;
  while (1) {
    int v;
    next = strstr(next, "start=");
    if (!next) break;
    if (sscanf(next+6, "%d", &v) != 1) goto end;
    if (v > start && (v < nstart || nstart == start))
      nstart = v;
    next++;
  }
  if (nstart > start) {
    start = nstart;
    Ss; S(", "); Se;
    goto more;
  }

end:
  if (page2) free(page2);
  Ss; S(";\n"); Se;
//  fprintf(sqlfile, ";\\n\";\n");
  fprintf(sqlfile, "?>\n");
  if (fclose(textfile) || fclose(sqlfile)) {
    printf("PANIC: error closing files\n");
    exit(1);
  }
}

int main(int n, char **v)
{
  com_init("users", n, v);

  login();
  acp_login();
  get_users();
  logout();

  com_fini();

  return 0;
}
